﻿Imports System.Collections.ObjectModel
Imports System.ComponentModel
Imports _4_3_PhoneBook.ViewModel

Class MainWindow
    Implements INotifyPropertyChanged

    Private Sub MainWindow_Loaded(sender As Object, e As RoutedEventArgs) Handles Me.Loaded
        AllContacts = New ObservableCollection(Of ContactViewModel)

        'For i As Integer = 0 To 4
        '    AllContacts.Add(New ContactViewModel(New Model.Contact() With {.FirstName = "Sascha" & i, .LastName = "Patschka",
        '                                         .Birthday = New Date(1983, 9, 12), .Note = "Eine Notiz",
        '                                         .ImagePath = "https://scontent-vie1-1.xx.fbcdn.net/v/t1.0-1/p200x200/101399477_4480021275357301_6743305723683274752_n.jpg?_nc_cat=103&_nc_sid=7206a8&_nc_ohc=jDJd3GJJF-AAX8sVc3C&_nc_ht=scontent-vie1-1.xx&_nc_tp=6&oh=c8d00f6c23bdd78b0d238a5100cb79d6&oe=5F5E94D9",
        '                                         .ContactData = New List(Of Model.ContactData) From {
        '                                            New Model.ContactData() With {.Data = "+43 664 1234567", .DataType = Model.EnumContactDataType.Phonenumber}}}))
        'Next

        Dim dp As New ContactsDataProvider()
        dp.GetAllContacts(True).ToList.ForEach((Sub(x) AllContacts.Add(New ContactViewModel(x))))

        Me.DataContext = Me
    End Sub


    Private _allContacts As ObservableCollection(Of ContactViewModel)
    Public Property AllContacts() As ObservableCollection(Of ContactViewModel)
        Get
            Return _allContacts
        End Get
        Set(ByVal value As ObservableCollection(Of ContactViewModel))
            _allContacts = value
            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(NameOf(AllContacts)))
        End Set
    End Property

    Private _selectedContact As ContactViewModel
    Public Property SelectedContact() As ContactViewModel
        Get
            Return _selectedContact
        End Get
        Set(ByVal value As ContactViewModel)
            _selectedContact = value
            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(NameOf(SelectedContact)))
        End Set
    End Property


    Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged

    Private Sub ContactItem_Click(sender As Object)
        SelectedContact = CType(CType(sender, Border).DataContext, ContactViewModel)
    End Sub


End Class

